// UnitGWPageAdv.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGWPageAdv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitGWPageAdv property page

IMPLEMENT_DYNCREATE(CUnitGWPageAdv, CPropertyPage)

CUnitGWPageAdv::CUnitGWPageAdv() : CPropertyPage(CUnitGWPageAdv::IDD)
{
	// Var
	CString str, strList;
	int     i, pos;

	//{{AFX_DATA_INIT(CUnitGWPageAdv)
	m_gwkeepalive	= AfxGetApp()->GetProfileInt(   "GPRS Options", "KEEPALIVE", 300);
	m_gwmaxconn		= AfxGetApp()->GetProfileInt(   "GPRS Options", "GW Maxconn", 3);
	m_gwmaxsend		= AfxGetApp()->GetProfileInt(   "GPRS Options", "GW Maxsend", 5);
	m_gwresptimeout = AfxGetApp()->GetProfileInt(   "GPRS Options", "GW Resptimeout", 45);
	//}}AFX_DATA_INIT

	// Get crypt key
	strList			= AfxGetApp()->GetProfileString("GPRS Options", "CRYPTKEY", "00000000-00000000-00000000-00000000");

	// Iterate cryptkey bytes
	pos = 0;
	for (i = 0; i < 16; i++)
	{
		// Insert byte
		m_crypt_key[i] = hatoi(strList.Mid(pos, 2));

		// Calculate next position
		pos += 2;
		if ((i + 1) % 4 == 0) pos++;
	}
}

CUnitGWPageAdv::~CUnitGWPageAdv()
{
}

void CUnitGWPageAdv::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitGWPageAdv)
	DDX_Control(pDX, IDC_SPINRESPTIMEOUT, m_gwspinresptimeout);
	DDX_Control(pDX, IDC_SPINMAXSEND, m_gwspinmaxsend);
	DDX_Control(pDX, IDC_SPINMAXCONN, m_gwspinmaxconn);
	DDX_Control(pDX, IDC_SPINKEEPALIVE, m_gwspinkeepalive);
	DDX_Control(pDX, IDC_CRYPT_KEY, c_cryptkey);
	DDX_Text(pDX, IDC_GWKEEPALIVE, m_gwkeepalive);
	DDV_MinMaxInt(pDX, m_gwkeepalive, 0, 60000);
	DDX_Text(pDX, IDC_GWMAXCONN, m_gwmaxconn);
	DDV_MinMaxInt(pDX, m_gwmaxconn, 1, 60);
	DDX_Text(pDX, IDC_GWMAXSEND, m_gwmaxsend);
	DDV_MinMaxInt(pDX, m_gwmaxsend, 1, 60);
	DDX_Text(pDX, IDC_GWRESPTIMEOUT, m_gwresptimeout);
	DDV_MinMaxInt(pDX, m_gwresptimeout, 5, 60);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitGWPageAdv, CPropertyPage)
	//{{AFX_MSG_MAP(CUnitGWPageAdv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitGWPageAdv::OnInitDialog() 
{
	// Default
	CPropertyPage::OnInitDialog();

	// Set controls
	m_gwspinkeepalive.SetRange32(0, 60000);	
	m_gwspinresptimeout.SetRange(5, 60);	
	m_gwspinmaxsend.SetRange(1, 60);	
	m_gwspinmaxconn.SetRange(1, 60);	
	UpdateData(false);

	// Set crypt key
	c_cryptkey.m_bpr = 8;
	c_cryptkey.SetOptions(false, true, false, false);
	c_cryptkey.SetData(m_crypt_key, 16);

	// Completed
	return TRUE;
}

void CUnitGWPageAdv::OnCancel() 
{
	// Var
	CString str, strList;

	// Get settings
	UpdateData(true);
	c_cryptkey.GetData(m_crypt_key, 16);

	// Iterate cryptkey bytes
	for (int i = 0; i < 16; i++)
	{
		// Insert byte
		str.Format("%02X", m_crypt_key[i]);
		strList += str;
		// Divider?
		if ((i + 1) % 4 == 0 && (i + 1) != 16) {
			// Insert divider
			strList += _T("-");
		}
	}

	// Save settings
	AfxGetApp()->WriteProfileInt(   "GPRS Options", "KEEPALIVE",      m_gwkeepalive);
	AfxGetApp()->WriteProfileInt(   "GPRS Options", "GW Maxconn",     m_gwmaxconn);
	AfxGetApp()->WriteProfileInt(   "GPRS Options", "GW Maxsend",     m_gwmaxsend);
	AfxGetApp()->WriteProfileInt(   "GPRS Options", "GW Resptimeout", m_gwresptimeout);
	AfxGetApp()->WriteProfileString("GPRS Options", "CRYPTKEY",       strList);

	// Default
	CPropertyPage::OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// Utility
/////////////////////////////////////////////////////////////////////////////

char CUnitGWPageAdv::hatoi(const CString& ha) const
{
	// Var
	char res = 0, i;

	// Iterate nibles
	for (i = 0; i < 2; i++) {
		// Move last nible
		res <<= 4;
		// Set nible
		if (ha.GetAt(i) >= '0' && ha.GetAt(i) <= '9')      res += (ha.GetAt(i) - '0');
		else if (ha.GetAt(i) >= 'a' && ha.GetAt(i) <= 'f') res += (ha.GetAt(i) - 'a' + 10);
		else if (ha.GetAt(i) >= 'A' && ha.GetAt(i) <= 'F') res += (ha.GetAt(i) - 'A' + 10);
	}

	// Completed
	return res;
}
