// UnitGWPageCfg.cpp : implementation file
//

#include "stdafx.h"
#include "rtcuprog.h"
#include "UnitGWPageCfg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUnitGWPageCfg property page

IMPLEMENT_DYNCREATE(CUnitGWPageCfg, CPropertyPage)

CUnitGWPageCfg::CUnitGWPageCfg() : CPropertyPage(CUnitGWPageCfg::IDD)
{
	//{{AFX_DATA_INIT(CUnitGWPageCfg)
	m_gwip		= AfxGetApp()->GetProfileString( "GPRS Options", "GWIP", "domain.net");
	m_gwkey		= AfxGetApp()->GetProfileString( "GPRS Options", "KEY", "AABBCCDD");
	m_gwport	= AfxGetApp()->GetProfileInt(    "GPRS Options", "PORT", 5000);
	m_gwenable	= AfxGetApp()->GetProfileInt(    "GPRS Options", "GW Enable", FALSE);
	//}}AFX_DATA_INIT
}

CUnitGWPageCfg::~CUnitGWPageCfg()
{
}

void CUnitGWPageCfg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUnitGWPageCfg)
	DDX_Control(pDX, IDC_SPINPORT, m_gwspinport);
	DDX_Text(pDX, IDC_GWIP, m_gwip);
	DDV_MaxChars(pDX, m_gwip, 32);
	DDX_Text(pDX, IDC_GWKEY, m_gwkey);
	DDV_MaxChars(pDX, m_gwkey, 8);
	DDX_Text(pDX, IDC_GWPORT, m_gwport);
	DDV_MinMaxInt(pDX, m_gwport, 1, 65535);
	DDX_Check(pDX, IDC_GWENABLE, m_gwenable);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUnitGWPageCfg, CPropertyPage)
	//{{AFX_MSG_MAP(CUnitGWPageCfg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Initiation / Destruction
/////////////////////////////////////////////////////////////////////////////

BOOL CUnitGWPageCfg::OnInitDialog() 
{
	// Default
	CPropertyPage::OnInitDialog();

	// Set controls
	m_gwspinport.SetRange32(1, 65535);	
	UpdateData(false);

	// Completed
	return TRUE;
}

void CUnitGWPageCfg::OnCancel() 
{
	// Get settings
	UpdateData(true);

	// Save settings
	AfxGetApp()->WriteProfileString( "GPRS Options", "GWIP",      m_gwip );
	AfxGetApp()->WriteProfileInt(    "GPRS Options", "PORT",      m_gwport );
	AfxGetApp()->WriteProfileString( "GPRS Options", "KEY",       m_gwkey );
	AfxGetApp()->WriteProfileInt(    "GPRS Options", "GW Enable", m_gwenable );

	// Default
	CPropertyPage::OnCancel();
}
